
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"
#include "csi.h"

extern void	Error(),ReadSliceImage();

int	main(argc,argv)
int	argc;
char	**argv;
{
	char		**paths;
	int		Nx,Ny,Nz,R,y,r,z,x;
	double		xO,yO,zO,base,step,d,rx,ry,rz,*S1,*S2,M,V;
	Cell		**cell;
	unsigned long	*S0;

	if (argc!=3 && argc!=5 && argc!=6 && argc!=8)
	    Error("usage : si_rp orgDir nameFile {xO yO zO} {base step}");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if (argc==3 || argc==5) {
	    xO=(double)(Nx-1)/2.0;
	    yO=(double)(Ny-1)/2.0;
	    zO=(double)(Nz-1)/2.0;
	}
	else {
	    xO=atof(argv[3]);
	    yO=atof(argv[4]);
	    zO=atof(argv[5]);
	}
	if (argc==3 || argc==6) {
	    base=0.0;
	    step=1.0;
	}
	else {
	    base=atof(argv[argc-2]);
	    step=atof(argv[argc-1]);
	}
	if ((d=fabs(xO))>(rx=fabs((double)(Nx-1)-xO))) rx=d;
	if ((d=fabs(yO))>(ry=fabs((double)(Ny-1)-yO))) ry=d;
	if ((d=fabs(zO))>(rz=fabs((double)(Nz-1)-zO))) rz=d;

	R=(int)sqrt(rx*rx+ry*ry+rz*rz)+2;

#define ALLOC(type,noe)	(type *)malloc(sizeof(type)*(noe))

	if ((cell=ALLOC(Cell *,(size_t)Ny))==NULL ||
	    (*cell=ALLOC(Cell,(size_t)Ny*(size_t)Nx))==NULL ||
	    (S0=ALLOC(unsigned long,(size_t)R))==NULL ||
	    (S1=ALLOC(double,(size_t)R))==NULL ||
	    (S2=ALLOC(double,(size_t)R))==NULL)
	    Error("memory allocation error.");

	for (y=1; y<Ny; y++) cell[y]=cell[y-1]+Nx;

	for (r=0; r<R; r++) S2[r]=S1[r]=(double)(S0[r]=0);

	for (z=0; z<Nz; z++) {
	    ReadSliceImage(paths[z],Nx,Ny,cell);

	    d=(double)z-zO; rz=d*d;
	    for (y=0; y<Ny; y++) {
		d=(double)y-yO; ry=rz+d*d;
		for (x=0; x<Nx; x++) {
		    d=(double)x-xO; ++S0[r=(int)(sqrt(ry+d*d)+0.5)];
		    S1[r]+=(d=base+step*(double)cell[y][x]); S2[r]+=(d*d);
		}
	    }
	}
	for (r=0; r<R; r++) {
	    M=(S0[r]==0)?0.0:S1[r]/(double)S0[r];
	    (void)printf("%d\t%lu\t%lf\t%lf\n",r,S0[r],M,
	    (S0[r]<=1 || (V=S2[r]/(double)S0[r]-M*M)<=0.0)?0.0:sqrt(V));
	}
	return 0;
}
