
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error(),RangeList();

static int	R_D(str,N)
char		*str;
int		N;
{
	int	D=(*str=='-')?(int)(atof(str+1)*(double)N+0.5):atoi(str);

	if (D<=0 || D>N) Error("bad correlation distance.");

	return D;
}

#define BINARY	unsigned char
#define CELL	(size_t)((Cell)(~0))
#define COUNT	unsigned int

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,Dx,Dy,BPS,X,Mx,Y,My,y,x,y0,x1,x2,dy,dx;
	Cell	**org,**new,c;
	BINARY	binary[CELL+1],**B;
	COUNT	**C;
	double	p,q,r,s;

	if (argc!=5 && argc!=7)
	    Error("usage : t_2cc orgTIFF rangeList {Dx Dy} BPS newTIFF");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&org,NULL);

	(void)printf("%d\t%d\n",Nx,Ny);

	RangeList(argv[2],CELL,binary);

	if (argc==5) {
	    Dx=Nx; Dy=Ny;
	}
	else {
	    Dx=R_D(argv[3],Nx);
	    Dy=R_D(argv[4],Ny);
	}
	(void)printf("%d\t%d\n",Dx,Dy);

	if ((BPS=atoi(argv[argc-2]))<=0 || BPS>8*sizeof(Cell))
	    Error("bad BPS.");

	Mx=Dx*2-1; X=1-Dx;
	My=Dy*2-1; Y=1-Dy;

	if ((C=(COUNT **)malloc(sizeof(COUNT *)*(size_t)Dy))==NULL ||
	    (*C=(COUNT *)malloc(sizeof(COUNT)*(size_t)Dy*(size_t)Mx))==NULL ||
	    (new=(Cell **)malloc(sizeof(Cell *)*(size_t)My))==NULL ||
	    (*new=(Cell *)malloc(sizeof(Cell)*(size_t)My*(size_t)Mx))==NULL)
	    Error("memory allocation error.");

	C-=Y; C[Y]-=X;
	for (y=Y+1; y<=0; y++) {
	    C[y]=C[y-1]+Mx; for (x=X; x<Dx; x++) C[y][x]=0;
	}
	for (y=1; y<My; y++) new[y]=new[y-1]+Mx;

	B=(BINARY **)org;
	for (y=0; y<Ny; y++) {
	    for (x=0; x<Nx; x++) B[y][x]=binary[org[y][x]];

	    y0=(y+Y>=0)?Y:-y;
	    for (x=0; x<Nx; x++) if (B[y][x]) {
		x1=(x+X>=0)?X:-x; x2=(x+Dx<=Nx)?Dx:Nx-x;
		for (dy=y0; dy<=0; dy++)
		for (dx=x1; dx<x2; dx++) C[dy][dx]+=B[y+dy][x+dx];
	    }
	}
	if (**C==0) Error("no object pixel.");

	(void)printf("%lf\n",p=(double)**C/(double)Nx/(double)Ny);

	q=(double)(c=(Cell)((1<<BPS)-1))/p;

	for (y=Y; y<=0; y++) {
	    r=q/(double)(Ny+y);
	    for (x=X; x<Dx; x++) new[y-Y][x-X]=new[-y-Y][-x-X]=
	((s=(double)C[y][x]*r/(double)(Nx-abs(x)))<=(double)c)?(Cell)(s+0.5):c;
	}
	StoreImageFile(argv[argc-1],Mx,My,BPS,new,NULL);

	return 0;
}
